#include <string>
#include <mqueue.h>
#include "queue.hxx"



class PosixQueue : public Queue
{
public:
  PosixQueue(const std::string& Name);
  virtual ~PosixQueue();

  virtual bool Open();
  virtual bool Close();
  virtual long int GetMessageCount() const;
  virtual bool Put(const char *pMessageBuffer, size_t MessageSize) const;
  virtual bool Get(char *pMessageBuffer, size_t BufferSize, size_t& MessageSize) const;
  virtual bool SetBlockingMode() const;
  virtual bool SetNonblockingMode() const;

  mqd_t        GetFileDescriptor() const; // just to support select(2) as a feature

private:
  std::string    m_Name;
  mqd_t          m_mqd;
  bool           m_bVerbose;
};
