#include <stdio.h>
#include "queue.hxx"
#include "dummy-queue.hxx"
#include "posix-queue.hxx"



static void HelloWorld(Queue *pQueue);



int main(int argc, char **argv)
{
  Queue *pQueue = 0;

  puts("\nHelloWorld test for DummyQueue...");
  pQueue = new DummyQueue();
  HelloWorld(pQueue);
  delete pQueue;

  puts("\nHelloWorld test for PosixQueue...");
  pQueue = new PosixQueue(std::string("TestQueue"));
  HelloWorld(pQueue);
  delete pQueue;

  return 0;
}



static void HelloWorld(Queue *pQueue)
{
  char aBuffer[512];
  size_t Length;

  if (pQueue->Open())
  {
    fprintf(stderr,"*** cannot open queue\n");
    return;
  }

  if (!pQueue->Put("Hello world!",13))
  {
    pQueue->SetNonblockingMode();
    if (!pQueue->Get(aBuffer,512,Length))
    {
      puts(aBuffer);
    }
    else
    {
      fprintf(stderr,"*** message not taken from queue\n");
    }
  }
  else
  {
    fprintf(stderr,"*** message not queued\n");
  }

  if (pQueue->Close())
  {
    fprintf(stderr,"*** error closing queue\n");
  }
}
